<?php

$layername = $_REQUEST['layer'];
$format = strtolower($_REQUEST['format']);

if (empty($format)) $format = 'json';

if ($this->isExist($layername)) {

	$blogname = get_bloginfo('name'); 
	$siteurl = site_url();
	$posts = get_posts();
	$hotspot = array();
	foreach($posts as $post) {
		$latitude = get_post_meta($post->ID, 'geo_latitude',true);
		$longitude = get_post_meta($post->ID, 'geo_longitude',true);
		
		$post_layer = get_post_meta($post->ID,'_rt_layername',true);
		
		$poi = array();
		
		if (is_numeric($latitude) && is_numeric($longitude) && $layername == $post_layer) {
			$geolocation = get_post_meta($post->ID, RT_GEOLOCATION, true);
			$address = $geolocation['address'];
			//$latitude = $geolocation['latitude'];
			//$longitude = $geolocation['longitude'];
			
			
			
			$mapzoom = $geolocation['zoom'];
			$maptype = $geolocation['maptype'];
			$use_custom_zoom = $geolocation['use_custom_zoom'];
			
			//$distance = getDistance($lat,$lon,$latitude,$longitude);
			
			//if ($distance < $radius) {
				$location = array(
					'lat'=>$latitude,
					'lon' => $longitude,	
					);

				
				$poi['id'] = $post->ID;
				$poi['anchor']	= array('geolocation' => $location) ;
				
				$content = get_wp_summary($post->post_content,100);
				$footnote = '<a href="'. get_permalink( $post->ID ).'">MORE</a> . By <a href="'.$siteurl.'">'.$blogname.'</a>';
				
				$poi['text'] = array (
					'title' =>$post->post_title,
					'description' => $content,
					'footnote' => $footnote
				);
				
				if ( has_post_thumbnail($post->ID) ) {
					//$poi['imageURL'] = get_the_post_thumbnail($post->ID, 'thumbnail');
					//$poi['imageURL'] = wp_get_attachment_url(get_the_post_thumbnail($post->ID, 'thumbnail'));
					$poi['imageURL'] = wp_get_attachment_url(get_post_thumbnail_id($post->ID)); //wp_get_attachment_thumb_url($post->ID);
				}
				
				
				
				$args = array(
					'post_type' => 'attachment',
					'numberposts' => null,
					'post_status' => null,
					'post_parent' => $post->ID
				);
				
				
				//ACTIONS
				$actions = array();
				$ri_poi_action = get_post_meta($post->ID, RT_POI_ACTION,true);
				
				if ($ri_poi_actions) {
				
					foreach($ri_poi_actions as $act1) {
						$action = array(
									'uri' => $act1['url'],
									'label' => $act1['label'],
							);
							
						array_push($actions,$act1);
					}
				}
				$attachments = get_posts($args);
				if ($attachments) {
					
					foreach ($attachments as $attachment) {
						
						$mime_type = $attachment->post_mime_type;

						$type = 3;
						$label = '';
						if (preg_match('/audio/',$mime_type)) $type = 1;
						
						else if (preg_match('/video/',$mime_type)) $type = 2;
						
						if ($type != 3) {
							$url = $attachment->guid;
							
							if ($type == 1) {
								$label = 'Play Audio';
								
							}
							else {
								$label = 'Play Video';
							}
							
							$action = array(
									'uri' => $url,
									'label' => $label,
									'contentType' => $mime_type
							);
							
							array_push($actions,$action);
						}
						
					}
					
				}
				
				if (count($actions) > 0) {
					$poi['actions'] = $actions;
				}
				
				//2D & 3D Objects and Transforms
				$object3d = get_post_meta($post->ID, RT_POI_3D, true);
				
				if ($object3d) {
					$upload_dir = wp_upload_dir();                    
					$dir = $upload_dir['baseurl'] . 'poifiles';
					$objectimage = urlencode($dir . '/' . $object3d['imagefile']);
					
					$poi['object'] = array(
						'contentType' => $object3d['content_type'],
						'url' => $objectimage
					);
					
					$transform = $object3d['transform'];
					$rotate = array('axis' =>  $transform['axis'], 'angle' => $transform['angle'], 'ref' => 'true');
									
					
					$poi['transform'] = array(
						'rotate' => $rotate,
						'translate' => $transform['trans'],
						'scale' => $transform['scale']
					);
				}
				
				array_push($hotspot,$poi);
				
			//}
		}
	}
	
	/*if (count($hotspot) > 0) {
		$errorcode = 0;
		$errormsg = 'ok';
	}
	else {
		$errorcode = 20;
		$errormsg = 'No any POI returned';
	}*/





$layar = array(
	'layer' => $layername,
	'hotspots' => $hotspot,
);

$filename = 'poi-'.$format.'-'.$layername.'-'.time();

switch($format) {
	case 'json':
		$poijson = json_encode($layar);
		$mimetype = 'application/json';
		break;
		
	case 'xml':
		
		$mimetype = 'text/xml';
		$xml = new SimpleXMLElement('<POI/>');
		array_to_xml($layar,$xml);
		$poijson = $xml->asXML();
		break;
	
	case 'array':
		
		$mimetype = 'plain/text';
		$poijson = var_export($layar,true);
		break;
}



//header('Content-Type: application/vnd.google-earth.kml+xml kml; charset=utf8');
header('Content-type: '.$mimetype.'; charset=utf-8');
header('Content-Disposition: attachment; filename="'.$filename.'.'.$format.'"');
header('Cache-Control: no-cache, must-revalidate');
//header('Expires: Mon, 26 Jul 1997 05:00:00 GMT');

echo $poijson;
exit;
}




?>