<?php

function getAddress($latitude, $longitude) {
		$url = "http://maps.google.com/maps/api/geocode/json?latlng=".$latitude.",".$longitude."&sensor=false";
		$result = wp_remote_get($url);
		
		
		
		if ($result['body']) {
			$json = json_decode($result['body']);
			$result = $json->results[0];
			
			if (isset($result->address_components)) {
				foreach($result->address_components as $addressPart) {
					
					if((in_array('locality', $addressPart->types)) && (in_array('political', $addressPart->types)))
						$city = $addressPart->long_name;
					else if((in_array('administrative_area_level_1', $addressPart->types)) && (in_array('political', $addressPart->types)))
						$state = $addressPart->long_name;
					else if((in_array('country', $addressPart->types)) && (in_array('political', $addressPart->types)))
						$country = $addressPart->long_name;
					
					else if (in_array('route', $addressPart->types)) {
						
						$route =  $addressPart->long_name;
					}
					else if (in_array('street_number', $addressPart->types)) {
						 $str_number = $addressPart->long_name;
					}
					
				}
				
				
				if (!empty($str_number))
					$address = $str_number . ' ';
				
				if (!empty($route))
					$address .= $route . ' ';
			}
		}
		
		return array($address,$city,$country);
}


function get_wp_summary($text,$len=60) {
 
  if (!empty($text)) {
	  $text = strip_tags(apply_filters('the_content', trim($text)));
	  $text = preg_replace('/\n/','',$text);
	  $text = str_replace(']]>', ']]&gt', $text);
	  $excerpt_length = $len;
	  
	  if (strlen($text) > $excerpt_length) {
		if (mb_detect_encoding($text) != 'ASCII')
			$text = mb_substr($text,0,$excerpt_length).   ' ... ';
		else
			$text = substr($text,0,$excerpt_length) .   ' ... ';
		}
   }
  return $text;
}


function array_to_xml($array,$xml) {
	
    foreach($array as $key => $value) {
        if(is_array($value)) {
            if(!is_numeric($key)){
                $subnode = $xml->addChild("$key");
                array_to_xml($value, $subnode);
            }
            else{
                array_to_xml($value, $xml);
            }
        }
        else {
            $xml->addChild("$key","$value");
        }
    }
}

function array_to_csv($arraydata, $delim = ",", $newline = "\n", $enclosure = '"')
{
	if ( ! is_array($arraydata))
	{
			die('You must submit a valid array of csv data');
	}       
	$out = '';
	// Next blast through the result array and build out the rows
	foreach ($arraydata as $row)
	{
			foreach ($row as $item)
			{
					$out .= $enclosure.str_replace($enclosure, $enclosure.$enclosure, $item).$enclosure.$delim;
			}
			$out = substr($out, 0, -1);
			$out = rtrim($out);
			$out .= $newline;
	}
	return $out;
}

function getPlaces() {
	global $wp_rt;
	
	return $wp_rt->getPlaces();
}


function objectToArray($d) {
		if (is_object($d)) {
			// Gets the properties of the given object
			// with get_object_vars function
			$d = get_object_vars($d);
		}
 
		if (is_array($d)) {
			/*
			* Return array converted to object
			* Using __FUNCTION__ (Magic constant)
			* for recursive call
			*/
			return array_map(__FUNCTION__, $d);
		}
		else {
			// Return array
			return $d;
		}
	}

function build_nav_menus() {
	global $wp_rt;
	
	return $wp_rt->build_nav_menus();
}

function get_markerslist() {

	$front_geomap = get_option("_RT_GEOLOCATION_OPTION");
	$myposts = get_posts($args);

	foreach( $myposts as $post ) {
		$id    = $post->ID;
		$title = $post->post_title;
		$cat   = $post->post_category;
		$dtmodified = $post->post_modified;
		$summary = (($post->post_excerpt!='')?$post->post_excerpt : substr($post->post_content,0,50));
		$url = get_permalink( $id );
		
		$latitude = get_post_meta($id, 'geo_latitude',true);
		$longitude = get_post_meta($id, 'geo_longitude',true);
		
		if (is_numeric($latitude) && is_numeric($longitude) ) {
			$geolocation = get_post_meta($post->ID, RT_GEOLOCATION, true);
					
			$address = $geolocation['address'];
			$city = $geolocation['city'];
			
			$location = array('lat' => $latitude, 'long' => $longitude, 'addr' => $address, 'town' => $city);
			$addr = $address .', '.$postcode .' '.$town;
			$htmlcode = '<h2><a href="'.$url.'" target="_blank">'.$title.'</a></h2>'.$summary.'<br/>'.$addr.'<br><a href="'.$url.'" target="_blank">More Detail</a>';
			
			$POST[] = 
			array(
				'id' => $id,
				'title' => $title,
				'url' => $url,
				'summary' => $summary,
				'modified' => $dtmodified,
				'location' => $location,
				'html' => $htmlcode,
			);
		} 
	}
	$array = array('def_location' => $front_geomap,  'post'=>$POST);
	
	return json_encode($array);
}


function get_embed_code() {
		$code = '<iframe src="'.RT_REL_URL.'/embed.php" width="\'+ w +\'" height="\'+ h +\'" frameborder="0"></iframe>';
		return $code;
}


function show_fgeorge_map($height = 300) {
	global $wp_rt;
	
	$wp_rt->get_map($height);
	
}

?>