<?php 

class rt_admin {
	public function __construct() {
		add_action( 'init', array( &$this, 'init' ) );
		
	}
	 
	public function init() {
	
		add_action('admin_menu', array(&$this,'admin_menus'));
		add_action('publish_post', array($this, 'save_geodata'));
		add_action('delete_attachment', array(&$this, 'delete_attachment'));
	}
	
	public function delete_attachment($postid) {
		$attachment = get_post($postid);
		
		if ($attachment->post_type == 'attachment') {
			if (preg_match('/video/',$attachment->post_mime_type) || preg_match('/audio/',$attachment->post_mime_type)) {
				$post_id = $attachment->post_parent;
				
				$medias = get_post_meta($post_id, RT_POI_ACTION_MEDIA,true);
				if ($medias && count($medias)>0) {
					$newarray = array();
					foreach($medias as $media) {
						if ($media['ID'] != $postid) {
							$newarray[] = $media;
						}
					}
					if (count($newarray) > 0) {
						update_post_meta($post_id, RT_POI_ACTION_MEDIA,$newarray);
					}
					else
						delete_post_meta($post_id, RT_POI_ACTION_MEDIA);
				}
				else
					delete_post_meta($post_id, RT_POI_ACTION_MEDIA);
			}
		}
	    
	}
	
	public function load_script() {
		wp_enqueue_script( 'jquery-ui-tabs' );
		
		wp_register_script( 'jquery-watermark', RT_JS_URL .'/jquery.watermark.min.js');
		wp_enqueue_script( 'jquery-watermark' );
		
		wp_register_style( 'custom_wp_admin_css', RT_REL_URL . '/themes/admin-styles.css', false, '1.0.0' );
        wp_enqueue_style( 'custom_wp_admin_css' );
	}
	
	function admin_menus() {
		global $rt_layer,$rt_images;
		
		//add_options_page('RT Layer Options', 'RT', 8, 'rt_setting', array(&$this, 'option_config_page'));
		add_meta_box('rt_location', __('Layar POI', 'rt'), array(&$this, 'rt_custom_box'), 'post', 'normal','high');
		
		add_menu_page( "RT", "FG Augmented Reality", 8, "rt-menu", array(&$rt_layer, 'display_layout') );
		
		add_submenu_page( "rt-menu", "Geolocation Layer", "Geolocation Layer", 8, "rt-menu", array(&$rt_layer, 'display_layout'));
		add_submenu_page( "rt-menu", "Layar Vision", "Layar Vision", 8, "rt-object", array(&$rt_images, 'display_layout'));
		add_submenu_page( "rt-menu", "Feedgeorge Augmented Reality Setting", "Settings", 8, "rt-setting", array(&$this, 'option_config_page'));
	}
	
	
	function rt_submenus() {
			
			
	}
	
	public function admin_head() {
		//wp_enqueue_script('inline-edit-tax');
        //echo '<link rel="stylesheet" href="' . RT_CSS_URL . '/rt_style_admin.css" />';
        echo '<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>'."\n";
        echo '<script type="text/javascript" src="'.RT_JS_URL . '/rt_admin.js"></script>';
		echo '<script type="text/javascript" src="'.RT_JS_URL . '/inline-edit-layer.js"></script>';
		
    }
    
	 
	function rt_custom_box() {
		
		global $post, $rt_layer;
		$geo_check = '';
		$rtgeo_options = get_option("_RT_GEOLOCATION_OPTION");
		$geolocation = get_post_meta($post->ID, RT_GEOLOCATION, true);
		
		$post_layer = get_post_meta($post->ID,'_rt_layername',true);
		$rtgeoOption = get_post_meta($post->ID, '_rt_geooption',true);
		
		$latitude = get_post_meta($post->ID, 'geo_latitude',true);
		$longitude = get_post_meta($post->ID, 'geo_longitude',true);
		
		$post_imagekey = get_post_meta($post->ID, 'poi_referenceimage', true);
		
		//get_post_meta($post_id, 'geo_public');
		
		if ($geolocation) {
			$address = $geolocation['address'];
			$city = $geolocation['city'];
			$mapzoom = $geolocation['zoom'];
            $maptype = $geolocation['maptype'];
            $use_custom_zoom = $geolocation['use_custom_zoom'];
		}
		
		if(!empty($latitude) && !empty($longitude)) {
			if (empty($address) && empty($city)) {
				list($address,$city,$country) = getAddress($latitude,$longitude);
			}
			if(empty($rtgeoOption)) $rtgeoOption = 2;
		}
        
        $post_geomap[latitude] = (empty($fgeo_options['post_map_latitude']))? RT_MAP_LAT : $rtgeo_options['post_map_latitude'];
        $post_geomap[longitude] = (empty($fgeo_options['post_map_longitude']))? RT_MAP_LNT : $rtgeo_options['post_map_longitude'];
        $post_geomap[map_zoom] = (empty($fgeo_options['post_map_zoom']))? RT_MAP_ZOOM : $rtgeo_options['post_map_zoom'];
		
		
        if (isset($use_custom_zoom) && $use_custom_zoom==1) {
            $geo_check = 'checked';
        }
		else
			$geo_check = '';
        
        $geomapdata = json_encode($post_geomap);
		
		$ri_poi_action = get_post_meta($post->ID, RT_POI_ACTION,true);
		$ri_yt_action = get_post_meta($post->ID, RT_POI_ACTION_YOUTUBE,true);
        $object3d = get_post_meta($post->ID, RT_POI_3D, true);
		$rt_autotri_range = get_post_meta($post->ID, RT_ACTION_AUTOTRI_RANGE,true);
		$rt_layer_radius = get_post_meta($post_id, RT_LAYER_RADIUS,true);
		
		if($object3d) $rt3dimage = $this->show_3d_image($object3d);
		if (isset($object3d['transform'])) {
			$transform = $object3d['transform'];
			$tsize = $object3d['size'];
		}
		else {
			$transform = array(
				'angle' => 0,
				'scale' => 1,
				'trans' => array('x'=>0,'y'=>0,'z'=>0),
				'axis' => array('x'=>0,'y'=>0,'z'=>0)
			);
			$tsize = 0.5;
		}
		
		$js_action = '[]';
		if ($ri_poi_action) {
			$js_action = json_encode($ri_poi_action);
		}
		
		$rtYTlist = '[]';
		if ($ri_yt_action) {
			$rtYTlist = json_encode($ri_yt_action);
		}
		
		$js_layer_list = json_encode($rt_layer->getList());
		
		$ri_act_media = get_post_meta($post->ID, RT_POI_ACTION_MEDIA,true);
		
		$RT_AR_VIDEO = get_post_meta($post->ID,RT_POI_AR_VIDEO,true);
		
        if (isset($geomapdata))
            $geo_option = '<script>var fg_post_map = '.$geomapdata.';</script>';
	
		
	
		include_once(RT_THEMES_DIR . '/location_form.php');
	}
	
	function show_3d_image($object3d) {
		$preview = RT_IMG_URL.'/l3d.png';
		if (preg_match('/image/',$object3d['content_type'])) {
			$upload_dir = wp_upload_dir();                    
			$dir = $upload_dir['baseurl'] . '/poifiles/';
			$preview = $dir . $object3d['imagefile'];
			$imagesize = print_r($object3d['imagesize'],true);
		}
		$image = '<table><tr><td><img src="'.$preview.'" width="50" align="absmiddle" /></td><td><strong>' . $object3d['imagefile'] . '</strong><br/>Content-type: '.$object3d['content_type'].' <br/><input type="checkbox" name="remove3D" id="remove3D" value="1">Remove? </td></tr></table>';
		
		return $image;
	}
	
	function option_config_page() {
        if (!current_user_can( 'manage_options' ))  {
            wp_die( __('You do not have sufficient permissions to manage options for this site.') );
        }
        
        if ( isset($_POST['act']) && $_POST['act'] == 'update' ) {
            
			$this->update_config();
        }
        
        $this->show_config_form();
    }
	
	
	function is_apikey($rt_options) {
		$fgapikey = $rt_options['feedgeorge_key'];

		if(isset($fgapikey) && strlen($fgapikey) == 64) {
			return true;
		}
		
		return false;
	}
	
	
	
	private function show_config_form() {
        global $current_blog;

        $rtgeo_options = get_option("_RT_GEOLOCATION_OPTION");
		
		$rt_total_poi = 50;
		if (isset($fgeo_options['layar'])) {
			$rt_total_poi = $fgeo_options['layar']['total_poi'];
		}
        require_once(RT_THEMES_DIR . '/config_form.php');
    }
	
	public function getConfig() { 
		$fgeo_options = get_option("_RT_GEOLOCATION_OPTION");
		return $fgeo_options;
	}
	
	function save_geodata($post_id) {
		global $wp_rt ;
		$post = get_post($post_id);
		if ( !current_user_can('edit_page', $post_id) ) return $post_id;
				
		if ( isset( $_POST['location_noncename'] ) && !wp_verify_nonce( $_POST['location_noncename'], plugin_basename( __FILE__ ) ) ) {
			return $post_id;
		}
		
		//$fg_option = $wp_rt->get_options();
		delete_post_meta($post_id, '_rt_layername');
		delete_post_meta($post_id, '_rt_geooption');
		delete_post_meta($post_id, 'poi_referenceimage');
		
		delete_post_meta($post_id, RT_GEOLOCATION);
				delete_post_meta($post_id, 'geo_latitude');
				delete_post_meta($post_id, 'geo_longitude');
				delete_post_meta($post_id, 'geo_city');
				delete_post_meta($post_id, 'geo_public');
		
		add_post_meta($post_id, '_rt_layername', $_POST['poilayer']);
		
		$geoOption = $_POST['poi-geoOption'];
		
		if ($geoOption == 1) {
			$reference = $_POST['poireferenceimage'];
			
			if ($reference != '-1') {
				add_post_meta($post_id, 'poi_referenceimage', $reference);
				add_post_meta($post_id, '_rt_geooption',$geoOption);
			}
		}
		else if ($geoOption == 2) {
			if ( isset($_POST['geo_latitude']) && isset($_POST['geo_longitude']) ) {
				
				if (isset($_POST['geo_mapzoom']) && preg_match('/^[0-9]+$/',$_POST['geo_mapzoom'])) {
					$zoom = $_POST['geo_mapzoom'];
				}
				
				if (isset($_POST['geo_maptype']) && preg_match('/^[a-zA-Z]+$/',$_POST['geo_maptype'])) {
					$maptype = $_POST['geo_maptype'];
				}
				
				if (isset($_POST['geo_iscustomzoom']) && $_POST['geo_iscustomzoom'] == 1)
					$use_custom_zoom = 1;
				else
					$use_custom_zoom = 0;
				
				$address = $_POST['geo_address'];
				$city = $_POST['geo_city'];
				
				if (empty($address) && empty($city)) {
					list($address,$city,$country) = getAddress($_POST['geo_latitude'],$_POST['geo_longitude']);
				}
				else if (empty($city)) {
					list($address1,$city,$country) = getAddress($_POST['geo_latitude'],$_POST['geo_longitude']);
				}
				
				$location = Array(
					'address' => $address,
					'city' => $city,
					'zoom' => $zoom,
					'maptype' => $maptype,
					'use_custom_zoom' => $use_custom_zoom,
				);
				
				add_post_meta($post_id, RT_GEOLOCATION, $location);
				add_post_meta($post_id, 'geo_city', $city);
				add_post_meta($post_id, 'geo_latitude', $_POST['geo_latitude']);
				add_post_meta($post_id, 'geo_longitude', $_POST['geo_longitude']);
				add_post_meta($post_id, 'geo_public', 1);
				add_post_meta($post_id, '_rt_geooption',$geoOption);
			}
		}
		$this->add_poi_action($post_id);
		$this->update_3DImage($post_id);
		
		if (isset($_POST['rt_layer_radius'])) {
			delete_post_meta($post_id, RT_LAYER_RADIUS);
			add_post_meta($post_id, RT_LAYER_RADIUS,strtolower($_POST['rt_layer_radius']));
		}
			
	}
	
	
	private function update_3DImage($postid) {
		$imagestype = array("png", "jpeg", "jpg", "gif");
		$ri_3d_data = get_post_meta($postid, RT_POI_3D,true);
		
		if (isset($_POST['remove3D']) && $_POST['remove3D'] == 1) {
			if ($ri_3d_data) {
				$upload_dir = wp_upload_dir();                    
				$dir = trailingslashit($upload_dir['basedir']) . 'poifiles';
				$objectimage = $dir . '/' . $ri_3d_data['imagefile'];
				
				if (file_exists($objectimage)) {
					unlink($objectimage);
				}
				
				
			}
			delete_post_meta($postid, RT_POI_3D);
		}
		
		else if (!empty($ri_3d_data)) {
			$trans = $_POST['trans'];
			$axis  = $_POST['taxis'];
			$scale = $_POST['tscale'];
			$angle = $_POST['tangle'];
			
			$ntransform = array(
				'angle' => $angle,
				'scale' => $scale,
				'trans' => $trans,
				'axis' => $axis
			);
			
			$size = $_POST['tsize'];
			$ri_3d_data['transform'] = $ntransform;
			$ri_3d_data['size'] = $size;
			
			update_post_meta($postid, RT_POI_3D,$ri_3d_data);
			
		}
	
		if(isset($_FILES['3dobject']) && @$_FILES['3dobject']['name']){
			delete_post_meta($postid, RT_POI_3D);
			
			$upload_dir = wp_upload_dir();                    
			$dir = trailingslashit($upload_dir['basedir']) . 'poifiles'; 
			
			if(!file_exists($dir)) {
				mkdir($dir, 0777);
			}
			list($file,$ext) = split('\.',$_FILES['3dobject']['name']);
			$ext = strtolower($ext);
			
			if ($ext == 'l3d') {
				$content_type = 'model/vnd.layar.l3d';
			}
			else if (in_array($ext,$imagestype)) {
				$content_type = 'image/vnd.layar.generic';
				$imagesize = getimagesize($_FILES['3dobject']['tmp_name']);
			}
			
			$imagefile = 'post_3d_' . $postid .'.'.$ext;
			$imagepath = $dir . '/' . $imagefile;
			
			$tmppath = $_FILES['3dobject']['tmp_name'];
			
			
			if(!move_uploaded_file($tmppath, $imagepath)){
						$error = sprintf(__("Unable to place the user photo at: %s", 'user-photo'), $imagepath);
			}
			
			$trans = $_POST['trans'];
			$axis  = $_POST['taxis'];
			$scale = $_POST['tscale'];
			$angle = $_POST['tangle'];
			
			$transform = array(
				'angle' => $angle,
				'scale' => $scale,
				'trans' => $trans,
				'axis' => $axis
			);
			
			$size = $_POST['tsize'];
			
			$poi3d = array('content_type' => $content_type,
						'size' => $size,
						'transform' => $transform,
						'imagefile' => $imagefile,
						'imagesize'=> $imagesize);
		
			
			add_post_meta($postid, RT_POI_3D, $poi3d);
		
		}
	}
	
	
	function add_poi_action($post_id) {
		
		if (isset($_POST['poiaction']) && !empty($_POST['poiaction'])) { 
			delete_post_meta($post_id, _RT_POI_ACTION);
			
			//$type = array(1=>'http://',2=>'tel:', 3=>'mailto:', 4=>'sms:');
			$poiaction = preg_replace('/&$/','',$_POST['poiaction']);
			$poiaction = split('&',$poiaction);
			$newarr = array();
			foreach($poiaction as $v) {
				$arr = split(',',$v);
				if($arr[3]==5) $arr[1] = $arr[1];
				array_push($newarr,$arr);
			}
			
			add_post_meta($post_id, RT_POI_ACTION,$newarr);
		}
		else {
			$action = get_post_meta($post_id, _RT_POI_ACTION,true);
			if ($action && count($action) > 0) {
				delete_post_meta($post_id, _RT_POI_ACTION);
			}
		}
		$autorange = 5;
		if (isset($_POST['rt_autotri_range'])) $autorange = $_POST['rt_autotri_range'];
		delete_post_meta($post_id, RT_ACTION_AUTOTRI_RANGE);
		add_post_meta($post_id, RT_ACTION_AUTOTRI_RANGE,$autorange);
		
		$attachments = get_posts( array(
					'post_type' => 'attachment',
					'numberposts' => null,
					'post_status' => null,
					'post_parent' => $post_id
				));
		if ($attachments) {
		
			$medialist = get_post_meta($post_id, RT_POI_ACTION_MEDIA,true);
			$selectlist = $_POST['rt_media'];
			
			foreach ($attachments as $attachment) {
				
				$mime_type = $attachment->post_mime_type;
				
				$type = 3;
				$label = '';
				$url = $attachment->guid;
				
				if (preg_match('/audio/',$mime_type)) $type = 1;
				else if (preg_match('/video/',$mime_type)) $type = 2;
				
				if ($type != 3) {
						
					if ($type == 1)
						$label = 'Play Audio - ' . substr($attachment->post_title,0,20) .'...';
					
					else 
						$label = 'Play Video - ' . substr($attachment->post_title,0,20) . '...';
					
					if (isset($_POST['rt_label_'.$attachment->ID]) && !empty($_POST['rt_label_'.$attachment->ID])) {
						$label = $_POST['rt_label_'.$attachment->ID];
					}
					
					$autot = $_POST['rt_autotri_'.$attachment->ID];
					
					if ($autot == 1) $autotriger=true;
					else $autotriger=false;
					
					if ( !isset($medialist[$attachment->ID]['selected'])) {
						$selected = true;
					}
					else {
						$selected = $medialist[$attachment->ID]['selected'];
						if (is_array($_POST['rt_media']) && in_array($attachment->ID,$_POST['rt_media'])) {
							$selected = true;
						}
						else
							$selected = false;
					}
						
					$action = array(
							'ID' => $attachment->ID,
							'title' => $attachment->post_title,
							'uri' => $url,
							'label' => $label,
							'contentType' => $mime_type,
							'autoTrigger'=> $autotriger,
							'autoTriggerOnly'=> $autotriger,
							'autoTriggerRange' => $autorange,
							'selected' => $selected,
					);
					$mediapost[$attachment->ID] = $action;
				}		
			}
			delete_post_meta($post_id, RT_POI_ACTION_MEDIA);
			delete_post_meta($post_id, RT_POI_AR_VIDEO);
			
			add_post_meta($post_id, RT_POI_ACTION_MEDIA,$mediapost);
			
			if (isset($_POST['rt_m_arvideo']) && $_POST['rt_m_arvideo'] == 1) 
				add_post_meta($post_id, RT_POI_AR_VIDEO,1);
		}
		else {
			if ($act_media) delete_post_meta($post_id, RT_POI_ACTION_MEDIA);
		}
		
		//poiYTaction
		//get_post_meta($post->ID, RT_POI_ACTION_YOUTUBE,true);
		if (isset($_POST['poiYTaction']) && !empty($_POST['poiYTaction'])) { 
			delete_post_meta($post_id, RT_POI_ACTION_YOUTUBE);
			
			$poiYTaction = preg_replace('/\|\|$/','',$_POST['poiYTaction']);
			$poiYTaction = split('\|\|',$poiYTaction);
			$newarr = array();
			$i=0;
			foreach($poiYTaction as $v) {
				$arr = split(',',$v);
				
				$arr[1] = $_POST['rt_label_' . $i];
				$arr[2] = $_POST['rt_autotri_' . $i];
				$arr[4] = $autorange;
				if (is_array($_POST['rt_yt']) && in_array($i,$_POST['rt_yt'])) {
					$arr[3]  = true;
				}
				else
					$arr[3] = false;
				
				
				array_push($newarr,$arr);
				$i++;
			}
			
			add_post_meta($post_id, RT_POI_ACTION_YOUTUBE,$newarr);
		}
		else {
			$action = get_post_meta($post_id, RT_POI_ACTION_YOUTUBE,true);
			if ($action && count($action) > 0) {
				delete_post_meta($post_id, RT_POI_ACTION_YOUTUBE);
			}
		}
	}
	
	
	function update_config() {
        global $current_blog;
        
        $fgeo_options = Array();
        $front_map = $_POST['front_map'];
        $content_map = $_POST['content_map'];
		$total_poi = $_POST['rt_total_poi'];
		
        if(isset($front_map)) {
            $fgeo_options['front_map_latitude']  = empty( $front_map['lat'] ) ?  RT_MAP_LAT : $front_map['lat'];
			$fgeo_options['front_map_longitude'] = empty( $front_map['long'] ) ? RT_MAP_LNT : $front_map['long'];
            $fgeo_options['front_map_zoom']      = $_POST['front_map_zoom'];
            
			$fgeo_options['front_map_width']      =  $front_map['width'];
			$fgeo_options['front_map_height']      = $front_map['height'];
        }
		
		if (isset($_POST['rt_fgeo_key']) && preg_match('/^[a-zA-Z0-9]+$/',$_POST['rt_fgeo_key'])) {
            $fgeo_options['feedgeorge_key'] = $_POST['rt_fgeo_key'];
        }
        
        
        if (isset($content_map)) {
            $fgeo_options['post_map_latitude']  = empty( $content_map['lat'] ) ?  '3.139003' : $content_map['lat'];
			$fgeo_options['post_map_longitude'] = empty( $content_map['long'] ) ? '101.68685499999992' : $content_map['long'];
            $fgeo_options['post_map_zoom']      = $_POST['content_map_zoom'];
     		$fgeo_options['post_map_width']      =  $content_map['width'];
			$fgeo_options['post_map_height']      = $content_map['height'];
 
        }
		
		if (empty($total_poi)) {
			$total_poi = 50;
		}
        
		$fgeo_options['layar'] = array(
					'total_poi' => $total_poi
					);
        
		update_option('_RT_GEOLOCATION_OPTION', $fgeo_options);
        
        echo "Update done";
    }
	
	
	public function update_layer() {
		global $rt_layer, $rt_images;
		
		if ( isset( $_POST['_rt_inline_edit'] ) && !wp_verify_nonce( $_POST['_rt_inline_edit'], plugin_basename( RT_REL_URL ) ) ) {
			echo -1;
			exit;
		}
		else if ($_POST['act2'] == 'rtimages') {
			$rt_images->update();
		}
		else 
			$rt_layer->update();
		
		exit;
	}
	
	
	function selectMapZoom( $return = 'array', $selected = '',$prefix = 'default' ) {

		// Array
		$map_type_array = array(
			'0' 	=> '0 - ' . 'Zoomed Out', 
			'1' 	=> '1', 
			'2' 	=> '2', 
			'3' 	=> '3', 
			'4' 	=> '4', 
			'5' 	=> '5', 
			'6' 	=> '6', 
			'7' 	=> '7', 
			'8' 	=> '8', 
			'9' 	=> '9', 
			'10' 	=> '10', 
			'11' 	=> '11', 
			'12' 	=> '12', 
			'13' 	=> '13', 
			'14' 	=> '14', 
			'15' 	=> '15', 
			'16' 	=> '16', 
			'17' 	=> '17', 
			'18' 	=> '18', 
			'19' 	=> '19 - ' . 'Zoomed In', 
		);
        
		if ($selected == '') $selected = 12;
        

		if ( $return = 'menu' ) {

            $menu = '';
			foreach ( $map_type_array as $key => $val ) {
				$is_selected = $selected == $key ? ' selected="selected"' : '';
				$menu .= '<option value="' . $key . '"' . $is_selected . '>' . $val . '</option>';
			}

			$menu = '<select name="'. $prefix .'_map_zoom" id="'.$prefix.'_map_zoom">' . $menu. '</select>';
			return $menu;
		}
		// Default return
		return $map_type_array;

	}
	
	
	
	 
}

?>