<?php
/**
 * Feedgeorge Augmented Reality Plugin feed class
 * 
 * @package Feedgeorge-Augmented-Reality-Plugin
 * @author CH Foo
 * @copyright 2012 Feedgeorge.com
 * @access public
 */
    class RT_feed {
        
        function __construct() {
            add_action( 'init', array( $this, 'init' ) );
        }
        
        function init() {
            add_feed( 'fgrss', array( 'FeedGeorge_Feeds', 'add_feed_georss' ) );
            add_filter( 'feed_content_type', array( $this, 'feed_content_type' ), 100 );
            //add_filter( 'post_limits', array( $this, 'post_limits' ) );
            $this->add_feed_hooks();
        }
        
        function add_feed_georss() {
            load_template( ABSPATH . 'wp-includes/feed-rss2.php' );
        }
        
        function add_feed_hooks() {
            add_action( 'rss2_ns', array( $this, 'georss_namespace' ) );
            add_action( 'atom_ns', array( $this, 'georss_namespace' ) );
            add_action( 'rdf_ns', array( $this, 'georss_namespace' ) );
            add_action( 'rss_item', array( $this, 'georss_item' ) );
            add_action( 'rss2_item', array( $this, 'georss_item' ) );
            add_action( 'atom_entry', array( $this, 'georss_item' ) );
            add_action( 'rdf_item', array( $this, 'georss_item' ) );
        }
        
        function feed_content_type( $type ) {
            if ( $type == 'georss' ) {
                $type = 'application/rss+xml';

            }
            return $type;
        }
        
        function georss_namespace() {
            echo 'xmlns:georss="http://www.georss.org/georss" xmlns:geo="http://www.w3.org/2003/01/geo/wgs84_pos#" xmlns:ymaps="http://api.maps.yahoo.com/Maps/V2/AnnotatedMaps.xsd"';
            
        }
        
        
        function georss_item() {
            global $post;

            $geolocation = get_post_meta($post->ID, RT_GEOLOCATION, true);         
			$latitude = get_post_meta($post->ID, 'geo_latitude',true);
			$longitude = get_post_meta($post->ID, 'geo_longitude',true);
			
            if(is_numeric($latitude) && is_numeric($longitude)) {
                
                $latitude = $this->clean_coordinate($latitude);
                $longitude = $this->clean_coordinate($longitude);
                // Need a map?
		
				echo '<georss:point>' . $latitude . ' ' . $longitude . '</georss:point>';
				echo '<geo:lat>' . $latitude . '</geo:lat>';
				echo '<geo:long>' . $longitude . '</geo:long>';
                
            }
            
        }
        
      
        
        function clean_coordinate($coordinate) {
            $pattern = '/^(\-)?(\d{1,3})\.(\d{1,15})/';
            preg_match($pattern, $coordinate, $matches);
            return $matches[0];
        }
        
    }

?>