<?php
class RT_layer {
	
	public function __construct() {
		global $wpdb;
		$this->prefix = $wpdb->prefix;
		
		$this->layertable = $this->prefix . 'layer';
		$this->poitable = $this->prefix . 'poi';
	}
	
	public function get($layer) {
		global $wpdb;
		
		if (empty($layer)) return null;
		
		$row = $wpdb->get_row('SELECT id, layer, isVision,radius,refreshInterval,refreshDistance,fullRefresh FROM ' . $this->layertable . ' where layer = "'.$layer.'"' );
		
		return $row;
	}
	
	public function getList() {
		global $wpdb;
		
		$myrows = $wpdb->get_results( 'SELECT id, layer, isVision,radius,refreshInterval,refreshDistance,fullRefresh FROM ' . $this->layertable );
		
		return $myrows;
	}
	
	public function getJson() {
		$lists = $this->getList();
		$array = array();
		foreach($lists as $list) {
			$array[$list->layer] = $list->isVision;
		}
		
		return json_encode($array);
	}
	
	public function isVision($layer) {
		global $wpdb;
		
		$isvision = $wpdb->get_var( $wpdb->prepare( 'SELECT isVision FROM '.$this->layertable.' where layer = %s',$layer ) );
		
		if ($isvision == 1)
			return true;
		
		return false;
	}
	
	public function getReferenceImage($imagekey) {
		global $wpdb;
		
		$lists = array(-1 => 'No Reference Image',1=>'mycoffee',2=>'ucsi1',3=>'sun1');
		
		if (empty($imagekey)) $imagekey = 'No Reference Image';
		
		foreach($lists as $key=>$list) {
			$selected = '';
			if ($imagekey == $list) $selected = 'selected';
			
			if ($key != -1) $key = $list;
			
			echo '<option value="'.$key.'" '.$selected.'>'.$list.'</option>';
		}
		
	}
	
	public function printOption($layer = '') {
		$lists = $this->getList();
		
		foreach($lists as $list) {
			$selected = '';
			if ($layer == $list->layer) $selected = 'selected';
			
			echo '<option '.$selected.'>'.$list->layer.'</option>';
		}
	}
	
	public function isExist($layer,$id='') {
		global $wpdb;
		
		if ($id > 0) {
			$id = $wpdb->get_var( $wpdb->prepare( 'SELECT id FROM '.$this->layertable.' where layer = %s and id <> %s',$layer,$id ) );
		}
		else
			$id = $wpdb->get_var( $wpdb->prepare( 'SELECT id FROM '.$this->layertable.' where layer = %s',$layer ) );
			
		if (!empty($id)) return true;
		
		return false;
	}
	
	
	public function isExistByID($id) {
		global $wpdb;
		
		$id = $wpdb->get_var( $wpdb->prepare( 'SELECT id FROM '.$this->layertable.' where id = %s',$id ) );
		
		if (!empty($id)) return true;
		
		return false;
	}
	
	public function display_layout() {
		$act = $_REQUEST['act'];
		$layername = $_REQUEST['layername'];
		
		switch($act) {
			case 'add' :
				$this->add($layername);
				break;
			
			case 'del' :
                $this->del($layername);
				break;
			
			case 'exportpoi':
				$this->exportPoi($layername);
				break;
			
			
		}
		
		$lists = $this->outputList($this->getList());
		
		require_once(RT_THEMES_DIR . '/layer-layout.php');

	}
	
	public function getTotalPOI($layer) {
		$posts = get_posts(array('numberposts' => -1));
		$count = 0;
		foreach($posts as $post) {
			$post_layer = get_post_meta($post->ID,'_rt_layername',true);
			
			if ($post_layer == $layer) $count +=1;
		}
		
		return $count;
	}
	
	
	public function assign($newlayer) {
		if (empty($newlayer)) return false;
	
		$posts = get_posts(array('numberposts' => -1));
		$count = 0;
		foreach($posts as $post) {
			$post_layer = get_post_meta($post->ID,'_rt_layername',true);
			
			update_post_meta($post->ID,'_rt_layername',$newlayer);
		}
		
		return true;
	}
	
	private function outputList($lists) {
		$listing = '';
		
		foreach($lists as $list) {
			$totalpoi = $this->getTotalPOI($list->layer);
			$listing .= '
			<tr id="tag-'.$list->id.'" class="alternate" >
				<th scope="row" class="check-column" ><input type="checkbox" id="layerid" name="layerid[]" value="'.$list->id.'" class="layer_row" /></th>
				<td class="name column-name">'.$list->layer.'
				<div class="row-actions">
				<span class="inline hide-if-no-js"><a href="#" class="editinline">Quick&nbsp;Edit</a> </div>
					<div class="hidden" id="inline_'.$list->id.'">
						<div class="name">'.$list->layer.'</div>
						<div class="isVision">'.($list->isVision==1?'YES':'NO').'</div>
						<div class="radius">'.$list->radius.'</div>
					</div>
				</td>
				<td>'.($list->isVision==1?'YES':'NO').'</td>
				<td>'.$totalpoi.'</td>
				<td>'.(($totalpoi > 0)?
				'<form action="" name="exportform_'.$list->id.'" id="exportform_'.$list->id.'" method="post" >
					<input type="hidden" name="layer" value="'.$list->layer.'" />
					<select id="format_'.$list->layer.'" name="format_'.$list->layer.'""><option>JSON</option><option>XML</option><option>ARRAY</option></select>
					<input type="button" id="export_'.$list->layer.'" name="export_'.$list->layer.'" class="expp_btn" value="Export POI"  />
				</form>':'').'
				</td>
			</tr>';
		}
		
		return $listing;
	}
	
	public function outputRadius($rad='') {
		global $RT_RADIUS;
		$list='';
		foreach($RT_RADIUS as $key=>$v) {
			$list .= '<option '.($key==$rad?'selected':'') .' value="'.$key.'" >'.ucfirst($key).'</option>';
		}
		return $list;
	}
	
	private function add($layername) {
		global $wpdb;
		
		$isvision = 0;
		
		if (empty($layername)) {
			echo 'No layer name submitted';
		}
		else {
			if (!$this->isExist($layername)) {
				if ($_POST['layar_isvision'] == 1) $isvision = 1;
				$radius = $_POST['rt_l_radius'];
				$sql = 'INSERT INTO '.$this->layertable.' (`layer`, `radius`,`refreshInterval`, `refreshDistance`, `fullRefresh`, `showMessage`, `biwStyle`, `isVision`) VALUES (%s, %s, 300, 100, 1, NULL, "classic",%s)';
				$wpdb->query( $wpdb->prepare($sql,$layername,$radius,$isvision));
				echo 'New Layer ['.$layername.']  added';
			}
			else
				echo 'The layer have exist. Please try another';
		}
	}
	
	
	private function del($layername) {
		global $wpdb;
		$ids = $_POST['layerid'];
		if (empty($ids) && count($ids) <= 0) {
			echo 'No layer name submitted';
		}
		else {
			foreach ($ids as $id) {
				if ($this->isExistByID($id)) {
					$sql = 'delete from '.$this->layertable.' where id = %s';
					$wpdb->query( $wpdb->prepare($sql,$id));
				}
			}
		}
	}
	
	
	
	public function update() {
		global $wpdb;
		
		$id = $_POST['ly_ID'];
		$layername = $_POST['name'];
		$radius = $_POST['rl_radius'];
		
		if ($_POST['rt_isvision'] == 1) 
			$isvision = 1;
		else
			$isvision = '0';
			
		if (empty($id)) {
			echo '-1';
		}
		else {
			if ($this->isExistByID($id)) {
				if (!$this->isExist($layername,$id)) {
					$sql = 'update '.$this->layertable.' set layer = %s, isVision=%s, radius = %s where id = %s';
					$wpdb->query( $wpdb->prepare($sql,$layername,$isvision,$radius,$id));
					echo 0;
				}
				else {
					echo 'The Layer have been taken';
				}
			}
			else
				echo 'The layer not exist';
		}
	}
	
	
	public function exportPoi($layername="") {
		
		include_once RT_DIR . '/exportpoi.php';
        
	}
	
	
}
?>