<?php
class RT_Layer_images {
	
	public function __construct() {
		global $wpdb;
		$this->prefix = $wpdb->prefix;
		
		$this->imagetable = $this->prefix . 'object';
	}
	
	
	public function getList($layar='') {
		global $wpdb;
		
		if (!empty($layer))
			$query = ' where layar = "' .$layar .'"';
		
		$myrows = $wpdb->get_results( 'SELECT id, imagekey, layar FROM ' . $this->imagetable . $query );
		
		return $myrows;
	}
	
	
	public function getJsonList() {
		$lists = $this->getList();
		
		$image = array();
		if (isset($lists)) {
			foreach($lists as $list) {
				
				if (!isset($image[$list->layar])) $image[$list->layar] = array();
				array_push($image[$list->layar],$list->imagekey);
			}
			
		}
		echo json_encode($image);
		
	}
	
	public function outputInSelectbox($layer,$imagekey) {
		global $wpdb;
		
		//$lists = array(-1 => 'No Reference Image',1=>'mycoffee',2=>'ucsi1',3=>'sun1');
		$images = $this->getList($layar);
		
		if (empty($imagekey)) $imagekey = 'No Reference Image';
		
		foreach($lists as $key=>$list) {
			$selected = '';
			if ($imagekey == $list) $selected = 'selected';
			
			if ($key != -1) $key = $list;
			
			echo '<option value="'.$key.'" '.$selected.'>'.$list.'</option>';
		}
		
	}
	
	
	public function isExist($key,$layar) {
		global $wpdb;
		
		$id = $wpdb->get_var( $wpdb->prepare( 'SELECT id FROM '.$this->imagetable.' where imagekey = %s and layar = %s',$key,$layar ) );
		
		if (!empty($id)) return true;
		
		return false;
	}
	
	
	public function isExistByID($id) {
		global $wpdb;
		
		$id = $wpdb->get_var( $wpdb->prepare( 'SELECT id FROM '.$this->imagetable.' where id = %s',$id ) );
		
		if (!empty($id)) return true;
		
		return false;
	}
	
	
	public function getInfo($id) {
		global $wpdb;
		$row = $wpdb->get_row( $wpdb->prepare( 'SELECT id,imagekey,layar FROM '.$this->imagetable.' where id = %s',$id ) );
		
		return $row;
	}
	
	public function display_layout($layar) {
		$act = $_REQUEST['act'];
		
		
		switch($act) {
			case 'add' :
				$this->add();
				break;
			
			case 'del':
				$this->del();
				break;
			
		}
		
		
		$lists = $this->outputList($this->getList($layer));
		
		
		require_once(RT_THEMES_DIR . '/images-layout.php');

	}
	
	
	public function printOption($layer = '') {
		global $rt_layer;
		
		$lists = $rt_layer->getList();
		
		foreach($lists as $list) {
			$selected = '';
			if ($list->isVision == 1) {
				if ($layer == $list->layer) $selected = 'selected';
				echo '<option '.$selected.'>'.$list->layer.'</option>';
			}
		}
	}
	

	private function outputList($lists) {
		$listing = '';
		
		foreach($lists as $list) {
			
			$listing .= '
			<tr id="tag-'.$list->id.'" class="alternate" >
				<th scope="row" class="check-column" ><input type="checkbox" id="rtimageid" name="rtimageid[]" value="'.$list->id.'" /></th>
				<td class="name column-name">'.$list->imagekey.'
				<div class="row-actions">
				<span class="inline hide-if-no-js"><a href="#" class="editinline">Quick&nbsp;Edit</a> </div>
				<div class="hidden" id="inline_'.$list->id.'"><div class="name">'.$list->imagekey.'</div><div class="rlayar">'.$list->layar.'</div></div>
				</td>
				<td>'.$list->layar.'</td>
				
			</tr>';
		}
		
		return $listing;
	}
	
	private function add() {
		global $wpdb;
		
		$layername = $_REQUEST['rtlayar'];
		$imagekey = $_REQUEST['imagekey'];
		
		if (empty($imagekey)) {
			echo 'No image key  submitted';
		}
		else {
			if (!$this->isExist($imagekey,$layername)) {
				$sql = 'INSERT INTO '.$this->imagetable.' (`layar`, `imagekey`, `dt_created`,`status`) VALUES (%s, %s, now(), 1)';
				$wpdb->query( $wpdb->prepare($sql,$layername,$imagekey));
				echo 'New Layer ['.$layername.']  added';
			}
			else
				echo 'The imagekey have exist. Please try another';
		}
	}
	
	
	private function del() {
		global $wpdb;
		$ids = $_POST['rtimageid'];
		if (empty($ids) && count($ids) <= 0) {
			echo 'No imagekey submitted';
		}
		else {
			foreach ($ids as $id) {
				$info = $this->getInfo($id);
				
				if ($info->id !='') {
					
					$posts = get_posts(array('numberposts' =>  -1));
					
					foreach($posts as $post) {
						$player = get_post_meta($post->ID, '_rt_layername',true);
						
						$pimage = get_post_meta($post->ID, 'poi_referenceimage',true);
					
						
						if ($pimage == $info->imagekey && $player == $info->layar) {
							delete_post_meta($post->ID, '_rt_geooption');
							delete_post_meta($post->ID, 'poi_referenceimage');
						}
					}
				
					$sql = 'delete from '.$this->imagetable.' where id = %s';
					$wpdb->query( $wpdb->prepare($sql,$id));
				}
			}
		}
	}
	
	
	
	public function update() {
		global $wpdb;
		
		$id = $_POST['ly_ID'];
		$key = $_POST['name'];
		$layarname = $_POST['rlayar'];
		
		if (empty($id)) {
			echo '-3';
		}
		else {
			if ($this->isExistByID($id) && !$this->isExist($key,$layername)) {
				$sql = 'update '.$this->imagetable.' set imagekey = %s, layar = %s where id = %s';
				$wpdb->query( $wpdb->prepare($sql,$key,$layarname,$id));
				echo 0;
			}
			else
				echo '-1' . $layarname;
		}
	}
	
	
}
?>