<?php
/**
 * RT Widget Class
 * 
 * @package rt_Wordpress_PLUGIN
 * @author CH Foo
 * @access public
 */
 
class RTGeoMapWidget extends WP_Widget {
    
    private $height = 200;
    
    /** constructor */
    function __construct() {
        global $wp_rt;
        parent::WP_Widget(false, $name = 'FG Story Map');	
        
        $rt_options = $wp_rt->get_options();
   
    }

    /** @see WP_Widget::widget */
    function widget($args, $instance) {		
        
        
			extract( $args );
			$title = apply_filters('widget_title', $instance['title']);
			$height = $instance['height'];
			$totalpost = esc_attr($instance['totalpost']);
			
			if (empty($height)) $height = $this->height;
            
        ?>
              <?php echo $before_widget; ?>
                  <?php if ( $title ) echo $before_title . $title . $after_title; ?>
				  <div id="rtwmap" style="width:100%; height:<?php echo $height; ?>px">
					<?php _e('Map is Loading... '); ?>
				  </div>
                  <script>
					var geoplace = <?php echo json_encode($this->getPosts($totalpost)) ?>;
					//jQuery(document).ready( function($){nearbymapWidget.init();});
				  </script>
				  <a id="viewmap" href="#" onclick='javascript:tb_show("Story Full Map","#TB_inline?height=500&width=800&inlineId=rtviewmap",null)'><?php _e('View Full Map') ?></a>
				  
				  <div id="rtviewmap" >
					<div id="rtfullmap" />Loading</div>
					<script>
					jQuery(document).ready( function($){
						var map3 = new rt_map('rtfullmap');
					});
					</script>
					<?php include(RT_THEMES_DIR . '/embed_form.php'); ?>
				  </div>
				  
              <?php echo $after_widget; ?>
        <?php
		
    }
	
	

    /** @see WP_Widget::update */
    function update($new_instance, $old_instance) {				
		$instance = $old_instance;
		$instance['title'] = strip_tags($new_instance['title']);
		$instance['height'] = $new_instance['height'];
		$instance['totalpost'] = $new_instance['totalpost'];
        return $instance;
    }

    /** @see WP_Widget::form */
    function form($instance) {				
        $title = esc_attr($instance['title']);
        $height = esc_attr($instance['height']);
		$totalpost = esc_attr($instance['totalpost']);
		 
		if (empty($height)) $height = 300;
		
		if ($title == '') $title = 'Story Map';
        ?>
		
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" /></label></p>
        <p><label for="<?php echo $this->get_field_id('height'); ?>"><?php _e('Height (px):'); ?> <input class="widefat" id="<?php echo $this->get_field_id('height'); ?>" name="<?php echo $this->get_field_name('height'); ?>" type="text" value="<?php echo $height; ?>" /></label></p>
        <p><label for="<?php echo $this->get_field_id('total'); ?>"><?php _e('Total post:'); ?> <input class="widefat" id="<?php echo $this->get_field_id('totalpost'); ?>" name="<?php echo $this->get_field_name('totalpost'); ?>" type="text" value="<?php echo $totalpost; ?>" /></label> </p>
        <?php 
    }
	
	
	private function getPosts($total=10) {
		
		$posts = get_posts(
			array(
				 'numberposts'     => $total,
				 'orderby'         => 'post_date',
				 'order'           => 'DESC',
				 'post_status'     => 'publish'
			)
		);
		
		foreach($posts as $post) {
			$latitude = get_post_meta($post->ID, 'geo_latitude',true);
			$longitude = get_post_meta($post->ID, 'geo_longitude',true);
		
			if (is_numeric($latitude) && is_numeric($longitude) ) {
				$posttitle =  get_post_meta($post->ID, WPGEO_LONGITUDE_META, true);
				$info = '<div id="fg_map_info"><h2><a href="'.get_permalink().'" >'.$post->post_title.'</a></h2><div class="summary">'.get_the_post_thumbnail($post->ID,'thumbnail',array('class'=>'thumbnail')).$location . '</div><div class="source"><a class="more" href="'.get_permalink().'">Detail</a></div></div>';
				$place[] = array($post->post_title,$latitude,$longitude,"$count",$info);
				
				//$markericon = '<div class="map_icon"><span class="map_icon_char">'.$count.'</span></div>';
				$count++; 
			}
		}
		
		return $place;
	}

}

?>