var fgmaps = null;
var prefix;
var marker;
var imagepath;
var fgmap = {
	
	init:function(pre) {
		prefix = pre;
		
		var lang =  parseFloat(fg_post_map['latitude']);
        var lnt =   parseFloat(fg_post_map['longitude']);
		
		if(!isNaN(lang) && !isNaN(lnt))
            em_LatLng = new google.maps.LatLng(lang,lnt);
        else
            em_LatLng = new google.maps.LatLng(3.14463,101.700439);
		
        var maptype = google.maps.MapTypeId.ROADMAP;
        var postzoom = parseInt(fg_post_map['map_zoom']);
        
		if(jQuery('#geo_iscustomzoom').is(':checked')){
			if (document.getElementById('geo_mapzoom').value != '' && document.getElementById('geo_iscustomzoom').checked) {
				postzoom = parseInt(document.getElementById('geo_mapzoom').value);
			}
			
			if (document.getElementById('geo_maptype').value != '') {
				maptype = document.getElementById('geo_maptype').value;
			}
		}
        
        fgmaps = new google.maps.Map( document.getElementById('wp_fgmap'), {
		    zoom: postzoom,
		    center: em_LatLng,
		    mapTypeId: maptype,
            streetViewControl: false,
		    scrollwheel: false,
		});
			
		this.setMarker();
		
		
        google.maps.event.addListener(fgmaps, 'zoom_changed', function() {
            document.getElementById('geo_mapzoom').value = fgmaps.getZoom();
        });

        google.maps.event.addListener(fgmaps, 'maptypeid_changed', function() {
            document.getElementById('geo_maptype').value = fgmaps.getMapTypeId();
        });
        

	},
	
	setMarker:function() {
		var lat = jQuery("input#"+ prefix +"_latitude").val();
		var lng = jQuery("input#"+ prefix +"_longitude").val();
		
		if (!isNaN(parseFloat(lat))  && !isNaN(parseFloat(lng))) {
			
			var myLatLng = new google.maps.LatLng(lat, lng);
			
			fgmaps.setCenter(myLatLng);
			
			if(marker) {
				marker.setPosition(myLatLng);
			}
			else {
				marker = new google.maps.Marker({
					position: myLatLng,
					map: fgmaps,
					draggable:true,
			    });
			  
			   google.maps.event.addListener(marker, 'dragstart', function() {
				//updateMarkerAddress('Dragging...');
			   });
			   
			   google.maps.event.addListener(marker, 'dragend', function() {
					point = marker.getPosition();
					jQuery("input#"+ prefix +"_latitude").val(point.lat());
					jQuery("input#"+ prefix +"_longitude").val(point.lng());
				});
			 
			}
		}
		
	},
	
	
	findLatLnt:function() {
		var address = jQuery("input#"+ prefix +"_address").val() 
		var city = jQuery("input#"+ prefix +"_city").val();
		
		if (city.length == 0) {
			alert('City field is empty');
			jQuery("input#"+ prefix +"_city").focus();
		}
		else {
			var geocoder = new google.maps.Geocoder();
			var location = address + ' ' + city;
			
			geocoder.geocode( { 'address': location}, function(results, status) {
			  if (status == google.maps.GeocoderStatus.OK) {
				point = results[0].geometry.location;
				jQuery("input#"+ prefix +"_latitude").val(point.lat());
				jQuery("input#"+ prefix +"_longitude").val(point.lng());
				
				fgmap.setMarker();
				jQuery("#poi_tabs").tabs({ disabled: [] });
			  } else {
				alert("Geocode was not successful for the following reason: " + status);
			  }
			});
		}
	}
};

function findLatLnt(prefix) {
	var address = jQuery("input#"+ prefix +"_location").val();
	
	if (address.length > 0) {
		var geocoder = new google.maps.Geocoder();
		
		geocoder.geocode( { 'address': address}, function(results, status) {
		  if (status == google.maps.GeocoderStatus.OK) {
			point = results[0].geometry.location;
			jQuery("input#"+ prefix +"_latitude").val(point.lat());
			jQuery("input#"+ prefix +"_longitude").val(point.lng());
			
			fgmap.setMarker();
			
			
		  } else {
			 alert("Geocode was not successful for the following reason: " + status);
		  }
		});
	}
	else {
		alert("Please enter location");
	}
};

function isValidEmail(emailAddress) {
    var pattern = new RegExp(/^(("[\w-+\s]+")|([\w-+]+(?:\.[\w-+]+)*)|("[\w-+\s]+")([\w-+]+(?:\.[\w-+]+)*))(@((?:[\w-+]+\.)*\w[\w-+]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$)|(@\[?((25[0-5]\.|2[0-4][\d]\.|1[\d]{2}\.|[\d]{1,2}\.))((25[0-5]|2[0-4][\d]|1[\d]{2}|[\d]{1,2})\.){2}(25[0-5]|2[0-4][\d]|1[\d]{2}|[\d]{1,2})\]?$)/i);
    return pattern.test(emailAddress);
};

function exportPOI(layer,format) {
	
	var ajaxurl = '/wp-admin/admin-ajax.php?action=exportpoi';
	
		jQuery('#exportpoifrm #layer').val(layer);
		jQuery('#exportpoifrm #format').val(format);
		
		document.getElementById('exportpoifrm').target = 'fg_upload_target';
		document.getElementById('exportpoifrm').action = ajaxurl;
		document.getElementById('exportpoifrm').submit();
	
	
};


jQuery(document).ready(function() {
	if (typeof fg_default_map !== 'undefined' ) imagepath = fg_default_map['dir'];
	
	if (document.getElementById('wp_fgmap')) {
		fgmap.init('geo');
		
		// Location search
		jQuery("#geo_search").click(function(e) {
			fgmap.findLatLnt();
			return false;
		});
		
	}
		
	// Location search
	jQuery("#load_map").click(function(e) {
		findLatLnt("default");
		return false;
	});
	
	jQuery("#default_location").change(function() {
		findLatLnt("default");
		return false;		
	});
	
	jQuery("#content_map_location").change(function() {
		findLatLnt("content_map");
		return false;		
	});
	
	jQuery("#content_load_map").click(function(e) {
		findLatLnt("content_map");
		return false;
	});
	
	
	
});

jQuery.fn.disabledThis = function(flag) {
	var o = jQuery(this[0]);
	if(flag) 
		o.css('background-color','#EAEAEA');
	else
		o.css('background-color','#FFF');
		
	o.attr('disabled',flag);
};


jQuery.fn.disabledThis = function(flag) {
	var o = jQuery(this[0]);
	if(flag) 
		o.css('background-color','#EAEAEA');
	else
		o.css('background-color','#FFF');
		
	o.attr('disabled',flag);
};

// Numeric only control handler
jQuery.fn.ForceNumericOnly =
function()
{
    return this.each(function()
    {
        jQuery(this).keydown(function(e)
        {
            var key = e.charCode || e.keyCode || 0;
            // allow backspace, tab, delete, arrows, numbers and keypad numbers ONLY
            return (
                key == 8 || 
                key == 9 ||
                key == 46 ||
				key == 190 ||   // normal .
                key == 110 ||   // keypad .
				key == 109 ||
				key == 189 ||
                (key >= 37 && key <= 40) ||
                (key >= 48 && key <= 57) ||
                (key >= 96 && key <= 105));
        });
		
		jQuery(this).blur(function() {
			if (this.value.indexOf('.')!=-1) {
				this.value = parseFloat(this.value);
				if (isNaN(this.value)) this.value = 0;
			}
			
			if (this.value.indexOf('-')!=-1) {
				if (isNaN(this.value)) this.value = 0;
			}
			
			
		});
    });
	
};