<?php

require(  dirname(dirname(dirname(dirname(__FILE__)))) . '/wp-load.php' );


$keys = array('layerName', 'lat', 'lon', 'radius');
$layername = $_REQUEST['layerName'];
$lat = $_REQUEST['lat'];
$lon = $_REQUEST['lon'];
$radius = $_REQUEST['radius'];

$rt_options = $rt_admin->getConfig();

if(!$rt_admin->is_apikey($rt_options)) {
	$errorcode = 22;
	$errormsg = 'API Key missing. You must acquire a Feedgeorge API Key for the AR Webservice.';
}
else {
if ($rt_options) {
	$totalposts = $rt_options['layar']['total_poi'];
}

if (empty($totalposts)) $totalposts = RT_NUMBER_POI;

if ($rt_layer->isExist($layername)) {
	
	$blogname = get_bloginfo('name'); 
	$siteurl = site_url();
	$posts = get_posts(array('numberposts' =>  $totalposts));
	$isVision = $rt_layer->isVision($layername);
	$hotspot = array();
	
	$layerinfo = $rt_layer->get($layername);
	$radius = $RT_RADIUS[$layerinfo->radius];
	
	foreach($posts as $post) {
		$post_layer = get_post_meta($post->ID,'_rt_layername',true);
		
		$poi_option = get_post_meta($post->ID, '_rt_geooption',true);
		$poi = array();
		$poi['id'] = $post->ID;
		
		if ($layername != $post_layer) continue;
		
		if ($poi_option == 2) {
			
			$geolocation = get_post_meta($post->ID, RT_GEOLOCATION, true);
			$latitude = get_post_meta($post->ID, 'geo_latitude',true);
			$longitude = get_post_meta($post->ID, 'geo_longitude',true);
			$address = $geolocation['address'];
			
			$mapzoom = $geolocation['zoom'];
			
			$distance = getDistance($lat,$lon,$latitude,$longitude);
			
			if ($distance <= $radius && is_numeric($latitude) && is_numeric($longitude)) {
				$location = array(
					'lat'=>$latitude,
					'lon' => $longitude,	
					);
				$poi['anchor']	= array('geolocation' => $location) ;
			}
			
		}
		else if ($poi_option == 1) {
			
			$post_imagekey = get_post_meta($post->ID, 'poi_referenceimage', true);
			$poi['anchor']	= array('referenceImage' => $post_imagekey) ;
		}
		
			if (isset($poi['anchor']) && is_array($poi['anchor'])) {
				$content = get_wp_summary($post->post_content,140);
				//$footnote = '<a href="'. get_permalink( $post->ID ).'">MORE</a> . By <a href="'.$siteurl.'">'.$blogname.'</a>';
				$footnote = 'by ' . $blogname;
				
				$poi['text'] = array (
					'title' =>$post->post_title,
					'description' => $content ,
					'footnote' => $footnote
				);
				
				if (!$isVision && has_post_thumbnail($post->ID) ) {
					//$poi['imageURL'] = get_the_post_thumbnail($post->ID, 'thumbnail');
					//$poi['imageURL'] = wp_get_attachment_url(get_the_post_thumbnail($post->ID, 'thumbnail'));
					$poi['imageURL'] = wp_get_attachment_url(get_post_thumbnail_id($post->ID)); //wp_get_attachment_thumb_url($post->ID);
				}
				
				$args = array(
					'post_type' => 'attachment',
					'numberposts' => null,
					'post_status' => null,
					'post_parent' => $post->ID
				);
				
				
				//ACTIONS
				$actions = array(
					array(
					'uri' => get_permalink( $post->ID ),
					'label' => 'More info',
					)
				);
				$ri_poi_actions = get_post_meta($post->ID, RT_POI_ACTION,true);
				
				if (is_array($ri_poi_actions) && count($ri_poi_actions) > 0) {
				
					for($i=0; $i<count($ri_poi_actions); $i++) {
						$act1 = $ri_poi_actions[$i];
						if($act1[3]==5) $act1[1] = $act1[1] . '/?action=refresh';
						$action = array(
									'uri' => $act1[1],
									'label' => $act1[2],
							);
							
						array_push($actions,$action);
					}
				}
				
				$actionYT = get_post_meta($post->ID, RT_POI_ACTION_YOUTUBE,true);
				if ($actionYT) {
					foreach($actionYT as $yt) {
						if ($yt[3] == 1) {
							$action = array(
									'uri' => $yt[0],
									'label' => $yt[1],
									"method"=> "GET",
								);
								
							if ($yt[2] == 1) {
								$action['autoTrigger'] = true;
								$action['autoTriggerOnly'] = true;
							}
							else {
								$action['autoTrigger'] = false;
								$action['autoTriggerOnly'] = false;
							}
							
							array_push($actions,$action);
						}
					}
				}
				
				$medias = get_post_meta($post->ID, RT_POI_ACTION_MEDIA,true);
				if($medias) {
					foreach($medias as $media) {
						if ($media['selected'] == 1) {
							$action = array(
								'uri' => $media['uri'],
								'label' => $media['label'],
								'contentType' => $media['contentType'],
								"method"=> "GET",
							);
							
							if ($isVision != 1) {
								$action['autoTriggerRange'] = $media['autoTriggerRange'];
							}
							
							if ($media['autoTrigger']) {
								$action['autoTrigger'] = true;
								$action['autoTriggerOnly'] = true;
							}
							else {
								$action['autoTrigger'] = false;
								$action['autoTriggerOnly'] = false;
							}
							array_push($actions,$action);
						}
					}
					
				}
				
				if (count($actions) > 0) {
					$poi['actions'] = $actions;
				}
				
				//2D & 3D Objects and Transforms
				$object3d = get_post_meta($post->ID, RT_POI_3D, true);
				if ($object3d) {
					$upload_dir = wp_upload_dir();                    
					$dir = $upload_dir['baseurl'] . '/poifiles';
					$objectimage = $dir . '/' . $object3d['imagefile'];
					
					if (!$isVision && preg_match('/image/',$object3d['content_type'])) {
						
						 $poi['icon'] = array(
							'url' => $objectimage,
							'type' => 2
						);
						
					}
					else {
						
						$poi['object'] = array(
							'contentType' => $object3d['content_type'],
							'url' => $objectimage,
							'size' => $object3d['size']
						);
						
						if (!$isVision) {
							$poi['object']['reducedURL'] = $objectimage;
						}
			
					}
					
					if (preg_match('/model/',$object3d['content_type'])) {
							//$poi['object']['size'] = $object3d['size'];
							$transform = $object3d['transform'];
							$rotate = array('axis' =>  $transform['axis'], 'angle' => $transform['angle'], 'ref' => 'true');
					
							$poi['transform'] = array(
								'rotate' => $rotate,
								'translate' => $transform['trans'],
								'scale' => $transform['scale']
							);
					}
						
					
				}

				array_push($hotspot,$poi);
			}
		
	}
	
	if (count($hotspot) > 0) {
		$errorcode = 0;
		$errormsg = 'ok';
	}
	else {
		$errorcode = 20;
		$errormsg = 'No any POI returned';
	}

}
else {
	$errorcode = 21;
	$errormsg = 'The layer not exist';
}
}

$layar = array(
	'layer' => $layername,
	'hotspots' => $hotspot,
	'radius' => $radius,
	'errorCode' => $errorcode,
	'errorString' => $errormsg,
);


$poijson = json_encode($layar);


header('Content-type: application/json; charset=utf-8');
echo $poijson;

exit;	


function getDistance($lat1,$long,$lat,$lon) {
	
	$distance = ((acos(sin(($lat1 * pi() / 180)) * sin(($lat * pi() / 180)) +
                   cos(($lat1 * pi() / 180)) * cos(($lat * pi() / 180)) * 
                   cos(($long  - $lon) * pi() / 180))
             ) * 180 / pi()
            ) * 60 * 1.1515 * 1.609344 * 1000;
			
	return $distance;
}


?>