<?php 

function rt_install() {

global  $wpdb, $user_level, $user_ID;

if( get_site_option('dbem_ms_global_table') ){
	$prefix = $wpdb->base_prefix;
}else{
	$prefix = $wpdb->prefix;
}

$layertbl = $prefix.'layer';
$objtbl = $prefix.'object';
$poitbl = $prefix.'poi';

$layarsql = "
CREATE TABLE IF NOT EXISTS ".$layertbl." (
  `layer` varchar(255) NOT NULL,
  `radius` varchar(10) NOT NULL,
  `refreshInterval` int(10) default '300',
  `refreshDistance` int(10) default '100',
  `fullRefresh` tinyint(1) default '1',
  `showMessage` varchar(255) default NULL,
  `isVision` tinyint(1) default '0',
  `id` int(11) unsigned NOT NULL auto_increment,
  `biwStyle` enum('classic','collapsed') default 'classic',
  PRIMARY KEY  (`id`),
  UNIQUE KEY `layer` (`layer`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=4
";

$objectsql = "
CREATE TABLE IF NOT EXISTS ".$objtbl." (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `layar` varchar(50) NOT NULL,
  `imagekey` varchar(60) NOT NULL,
  `dt_created` datetime NOT NULL,
  `status` int(11) NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 AUTO_INCREMENT=5
";

$poisql = "
CREATE TABLE IF NOT EXISTS ".$poitbl." (
  `id` bigint(20) unsigned NOT NULL auto_increment,
  `footnote` varchar(100) collate utf8_unicode_ci NOT NULL,
  `title` varchar(100) collate utf8_unicode_ci NOT NULL,
  `lat` double(10,6) default NULL,
  `lon` double(10,6) default NULL,
  `imageURL` varchar(100) collate utf8_unicode_ci NOT NULL,
  `description` text collate utf8_unicode_ci NOT NULL,
  `layer_id` bigint(20) NOT NULL,
  `postid` bigint(20) NOT NULL,
  `layar_name` varchar(100) collate utf8_unicode_ci NOT NULL,
  `alt` int(10) default NULL,
  `status` tinyint(2) NOT NULL,
  `dt_created` datetime NOT NULL,
  `dt_modified` datetime NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE=utf8_unicode_ci AUTO_INCREMENT=1";


require_once(ABSPATH . 'wp-admin/includes/upgrade.php'); 

dbDelta($layarsql);
dbDelta($objectsql);
dbDelta($poisql);


}


function rt_uninstall() {
	global  $wpdb, $user_level, $user_ID;

	if( get_site_option('dbem_ms_global_table') ){
		$prefix = $wpdb->base_prefix;
	}else{
		$prefix = $wpdb->prefix;
	}

	$layertbl = $prefix.'layer';
	$objtbl = $prefix.'object';
	$poitbl = $prefix.'poi';
	
	$layarsql = "drop table ".$layertbl;
	$objectsql = "drop table ".$objtbl;
	$poisql  = "drop table ".$poitbl;

	$wpdb->query($layarsql);
	$wpdb->query($objectsql);
	$wpdb->query($poisql);

	
}