<?php
/**
 * @package Feedgeorge Augmented Reality Plugin
 * @version 1.1
 */
/*
Plugin Name: Feedgeorge Augmented Reality Plugin
Plugin URI: http://wordpress.feedgeorge.com/augmented-reality-plugin/
Description: Feedgeorge is a platform to discover, create and share news, information and data about places. It aggregates location data in a single platform. To help WordPress users with a better geotagging experience, we introduce you Feedgeorge WordPress Plugin (FGWPP).
Author: C H Foo
Version: 1.0.2.1
Author URI: http://wordpress.feedgeorge.com/
*/

/*

Copyright (c) 2012, C H Foo, Feedgeorge

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

*/

define( 'RT_VERSION', '1.0.2.1' );

define( 'RT_DIR', dirname(__FILE__) );
define('RT_NAME', basename( RT_DIR ));
define( 'RT_REL_URL', plugins_url( $path = '/' . basename( dirname( __FILE__ ) ) ) );
define( 'RT_THEMES_DIR', RT_DIR . '/themes' );
define( 'RT_INCLUDE_DIR', RT_DIR . '/includes' );
define( 'RT_JS_DIR', RT_DIR . '/js' );
define( 'RT_JS_URL', RT_REL_URL . '/js' );
define( 'RT_CSS_URL', RT_REL_URL . '/css' );
define( 'RT_IMG_URL', RT_REL_URL . '/images' );

define( 'RT_WEBSERVICE_URL', RT_REL_URL . '/layarservice.php' );
define( 'FG_APISITE', 'http://www.feedgeorge.com/apisignup');

/* Default variable */
define('RT_GEOLOCATION', '_RT_GEOLOCATION');
define('RT_POI_3D', '_RT_POI_3D');
define('RT_POI_ACTION', '_RT_POI_ACTION');
define('RT_POI_ACTION_MEDIA','_RT_POI_ACTION_MEDIA');
define('RT_POI_ACTION_YOUTUBE','_RT_POI_ACTION_YOUTUBE');
define('RT_POI_AR_VIDEO','_RT_POI_AR_VIDEO');
define('RT_ACTION_AUTOTRI_RANGE','_RT_ACTION_AUTOTRI_RANGE');
define('RT_LAYER_RADIUS','_RT_LAYER_RADIUS');

define('RT_MAP_HEIGHT', 300);
define('RT_MAP_ZOOM', 14);
define('RT_MAP_LAT', 3.14463);
define('RT_MAP_LNT',101.700439);
define('RT_MAP_MARKER', 'map-marker.png');
define('RT_MAP_SMALL_MARKER', 'map_small_marker.png');
define('RT_NUMBER_POI', 50);

define('RT_KEY01','ed6c7e54f052dc113c75b5b5f09c3c62hj123mj');

$RT_RADIUS = array('far'=>2000,'medium'=>500,'near'=>10);

global $rt_admin;

require_once('includes/wp-rt.php');
require_once('includes/rt_admin.php');
require_once('includes/rt_layer.php');
require_once('includes/rt_layer_images.php');
require_once('includes/rt_widget.php');
require_once('includes/rt_feed.php');
require_once('includes/functions.php');
require_once('rt_install.php');

//Initialize the WordPress Controller and set it up.
$wp_rt   = new WP_RT();
$rt_admin = new rt_admin();
$rt_layer = new RT_layer();
$rt_images = new RT_Layer_images();
$rt_feed = new RT_feed();

//Register the activation hook
register_activation_hook( __FILE__, Array( &$wp_rt , 'init_plugin' ) );

//Register the deactivation hook
register_deactivation_hook( __FILE__, Array( &$wp_rt , 'kill_plugin' ) );

//Register the uninstall hook
register_uninstall_hook( __FILE__, array( &$wp_rt , 'uninstall_plugin' ) );


?>